package com.joelhelkala.watcherGui.frames;

import java.awt.*;
import javax.swing.*;

import com.joelhelkala.watcherGui.User.User;
import com.joelhelkala.watcherGui.frames.panels.LineChartPanel;
import com.joelhelkala.watcherGui.frames.panels.ProgressBarCirclePanel;

public class WelcomePage {
		
	private static final int width = 1200, height = 750;
	private static final int topPanelHeight = height/10;
	private static final int leftPanelWidth = width/5;
	private static final int cardPanelHeight = (height-topPanelHeight-height/11)/2;
	private static final int cardWidth = 300;
	
	private static final Color gray = new Color(45, 45, 45);
	private static final Color lightgray = new Color(73, 73, 73);
	private static final Color darkwhite = new Color(96, 96, 96);
	private static final Color dark = new Color(33, 33, 33);
	
	public WelcomePage(){	
		JPanel topPanel = new JPanel();
		topPanel.setBackground(dark);
		topPanel.setBounds(0,0,width, topPanelHeight);
		
		JPanel leftPanel = new JPanel();
		leftPanel.setBackground(dark);
		leftPanel.setBounds(0, topPanelHeight, leftPanelWidth, height);
		
		JPanel bottomPanel = new JPanel();
		bottomPanel.setBackground(gray);
		bottomPanel.setBounds(leftPanelWidth, height-height/11, width, height/11);
		
		JPanel cardPanel = new JPanel();
		cardPanel.setBackground(gray);
		cardPanel.setBounds(leftPanelWidth, topPanelHeight, width-leftPanelWidth, cardPanelHeight);
		cardPanel.setLayout(null);
		
		JPanel card1 = new JPanel();
		card1.setBackground(lightgray);
		card1.setBounds(15, 10, cardWidth, cardPanelHeight-20);
		cardPanel.add(card1);
		
		JPanel card2 = new ProgressBarCirclePanel().makeUI();
		card2.setBackground(lightgray);
		card2.setBounds(cardWidth+30, 10, cardWidth, cardPanelHeight-20);
		cardPanel.add(card2);
		
		JPanel card3 = new JPanel();
		card3.setBackground(lightgray);
		card3.setBounds(cardWidth*2+45, 10, cardWidth, cardPanelHeight-20);
		cardPanel.add(card3);
		
		JPanel chartPanel = new JPanel();
		chartPanel.setBackground(gray);
		chartPanel.setBounds(leftPanelWidth, topPanelHeight+cardPanelHeight, width-leftPanelWidth, cardPanelHeight);
		chartPanel.setLayout(null);
		
		JPanel chart = new LineChartPanel("Temperature").getPanel();
		chart.setBackground(darkwhite);
		chart.setBounds(15, 10, width - leftPanelWidth - 30, cardPanelHeight - 20);
		chartPanel.add(chart);
		
		JFrame frame = new JFrame();
		frame.getContentPane().setBackground( new Color(128, 127, 137) );
		frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		frame.getContentPane().setLayout(null);
		frame.setSize(width, height);
		frame.setLocationRelativeTo(null);
		
		frame.getContentPane().add(topPanel);
		topPanel.setLayout(null);
		
		JLabel userLabel = new JLabel("Hello, " + User.getName());
		userLabel.setBounds(1060, 32, 71, 16);
		userLabel.setHorizontalAlignment(SwingConstants.CENTER);
		userLabel.setForeground(Color.WHITE);
		topPanel.add(userLabel);
		JLabel iconLabel = new JLabel();
		iconLabel.setBounds(20,10,50,50);
		ImageIcon image = new ImageIcon("src/main/resources/images/lightbulb_on.png");
		iconLabel.setIcon(LoginPage.resizeIcon(image, 50, 50));
		topPanel.add(iconLabel);
		JLabel titleLabel = new JLabel("WATCHER");
		titleLabel.setForeground(Color.yellow);
		titleLabel.setBounds(100, 0, 100, 50);
		topPanel.add(titleLabel);
		frame.getContentPane().add(leftPanel);
		leftPanel.setLayout(null);
		
		JLabel nodeDataLabel = new JLabel("Node data");
		nodeDataLabel.setHorizontalAlignment(SwingConstants.CENTER);
		nodeDataLabel.setFont(new Font("Apple SD Gothic Neo", Font.PLAIN, 16));
		nodeDataLabel.setBounds(64, 57, 98, 16);
		nodeDataLabel.setForeground(Color.WHITE);
		leftPanel.add(nodeDataLabel);
		
		JLabel nodeSettingsLabel = new JLabel("Node settings");
		nodeSettingsLabel.setHorizontalAlignment(SwingConstants.CENTER);
		nodeSettingsLabel.setForeground(Color.WHITE);
		nodeSettingsLabel.setFont(new Font("Apple SD Gothic Neo", Font.PLAIN, 16));
		nodeSettingsLabel.setBounds(64, 110, 98, 16);
		leftPanel.add(nodeSettingsLabel);
		
		JLabel friendsLabel = new JLabel("Friends");
		friendsLabel.setHorizontalAlignment(SwingConstants.CENTER);
		friendsLabel.setForeground(Color.WHITE);
		friendsLabel.setFont(new Font("Apple SD Gothic Neo", Font.PLAIN, 16));
		friendsLabel.setBounds(64, 163, 98, 16);
		leftPanel.add(friendsLabel);
		
		JLabel helpLabel = new JLabel("Help");
		helpLabel.setHorizontalAlignment(SwingConstants.CENTER);
		helpLabel.setForeground(Color.WHITE);
		helpLabel.setFont(new Font("Apple SD Gothic Neo", Font.PLAIN, 16));
		helpLabel.setBounds(20, 615, 98, 16);
		leftPanel.add(helpLabel);
		
		JLabel settingsLabel = new JLabel("Settings");
		settingsLabel.setHorizontalAlignment(SwingConstants.CENTER);
		settingsLabel.setForeground(Color.WHITE);
		settingsLabel.setFont(new Font("Apple SD Gothic Neo", Font.PLAIN, 16));
		settingsLabel.setBounds(123, 615, 98, 16);
		leftPanel.add(settingsLabel);
		frame.getContentPane().add(cardPanel);
		frame.getContentPane().add(chartPanel);
		frame.getContentPane().add(bottomPanel);
		
		frame.setVisible(true);
	}
}